package hydraulic;

import java.util.Observer;

public class HSystem {
	
	private Element[] elements;
	
	private Observer observer;
	
	// NEW CONSTRUCTOR!!!
	public  HSystem(Observer obs){
		observer = obs;
		elements = new Element[100];
	}

	public void addElement(Element elem){
		for (int i = 0; i < elements.length; i++) {
			if(elements[i] == null){
				elements[i] = elem;
				elem.addObserver(observer);
				return;
			}
		}
		System.err.println("It was not possible to add the element: array full.");
	}
	
	public Element[] getElements(){
		return elements;
	}
	
	public void simulate(){
		for(Element e : elements){
			if( e instanceof Source){
				e.simulate(-1);
			}
		}
	}
}
