package hydraulic;

import java.util.Observable;

public class Element extends Observable { // NEW BASE CLASS

	private String name;
	protected Element[] outputs;
	
	public Element(String name){
		this.name=name;
		outputs = new Element[1];
	}
	
	public Element(String name, int numOutputs){
		this.name = name;
		outputs = new Element[numOutputs];
	}
	
	public String getName(){
		return name;
	}
	
	public void connect(Element elem){
		connect(elem,0);
	}
	
	public Element getOutput(){
		return getOutputs()[0];
	}
	
    protected Element[] getOutputs(){
        return outputs;
    }

	protected void connect(Element elem, int output){
		outputs[output] = elem;
	}

	public void simulate(double inputFlow){
		
	}
	
}
