package hydraulic;

/**
 * This class contains the information
 * concerning the simulation of and element
 * of the hydraulic system.
 */
public class HEvent {

	public final Element element;
	public final double input;
	public final double[] outputs;

	public HEvent(Element e, double in, double[] out){
		element = e;
		input = in;
		outputs = out;
	}

	public HEvent(Element e, double in, double out){
		element = e;
		input = in;
		outputs = new double[]{out};
	}
}
