package hydraulic;

public class Source extends Element {

	private double flow;

	public Source(String name) {
		super(name);
	}

	public void setFlow(double flow){
		this.flow = flow;
	}

	public void simulate(double inputFlow) {
		
		double outputFlow = flow;
		
		setChanged();
		HEvent event = new HEvent(this,inputFlow,outputFlow);
		notifyObservers(event);
		
		getOutput().simulate(outputFlow);
	}
}
